/******************************************/ 
/* Carbon-compatible section of OroborOSX */
/* (c) Adrian Umpleby Jan 2002            */
/*                                        */
/* Original oroborus window manager code  */
/* (c) Ken Lynch Jan 2001                 */
/*                                        */
/* Distributed under the GPL              */ 
/* See LICENSE for more details           */ 
/******************************************/ 

/* main.h */

#ifndef MAIN_H 
#define MAIN_H 

#include <stdlib.h> 
#include <stdio.h> 

#include <Carbon/Carbon.h>

#include "common.h"

// Various window identifiers
#define x11Wintype	0
#define noFocusWintype	1
#define aboutWintype	10
#define waiting1Wintype	11
#define waiting2Wintype	12
#define waiting3Wintype	13
#define passwordWintype	100

// Control IDs
#define PWTX_CTRL_ID	1
#define OK_CTRL_ID	100
#define CNCL_CTRL_ID	101
#define RDME_CTRL_ID	101
#define HIST_CTRL_ID	102
#define LCNC_CTRL_ID	103

// Name to look for when checking to see if XDarwin is already running
#define XDARWIN_NAME "XDarwin"
#define XDARWIN_NAMELEN 7

#define README_FILEID	1
#define THEMES_FILEID	2
#define LICENSE_FILEID	3
#define HISTORY_FILEID	4

typedef struct{
    char len;
    char thestr[256];
} pstr_t;

/* common to main.c and osxwindows.c or menus.c or macevents.c */
extern WindowRef	lastFrontWin, noFocusWin, aboutWin;
extern WindowRef	waiting1Win, waiting2Win, passwordWin, alertWin;
extern int		gInited, showingAboutWin, showingNoFocusWin, showingAlert, gotControlEvent;
extern int		gInvisible, cycleOff, lastrl_x, lastrl_y, gQuietStartup;
extern long		lastOKTicks, lastMovedTicks;
extern ProcessSerialNumber	xPSN, myPSN;
extern Rect		gMainRect;
extern Boolean		forceOOSXInFront;

/* main.c */
extern void ShowGeneralFile(char *name);
extern void ShowOroborOSXHelp(void);
extern void DoIdle(int trackMouse);
extern void ShowAboutThisTheme(void);
extern void ShowThemesInfoFile(void);
extern void ShowLicenseFile(void);
extern void ShowHistoryFile(void);
extern void InitPrefs(void);
extern void SavePrefs(void);

/* osxwindows.c */
extern int DestroyBadWindows(WindowRef checkinlist);
extern void DrawWindow(WindowRef window);
extern WindowRef MakeAlertWindow(const char *name);
extern WindowRef MakeWindow(int windowtype);
extern void DoPasswordWindow(void);
extern void DoAboutBox(void);

/* macevents.c */
extern void OpenXDarwinPrefs(void);
extern void EventLoop(void);
extern void DoEvent(EventRecord *event);
extern void DoIdle(int trackMouse);
extern void InitAEHandlers(void);

/* menus.c */
extern void MakeMenu(void);
extern void DoMenuCommand(long menuResult, short menuID, short menuItem);
extern int LaunchMenuItem(char *itemname, int hasext, int hasnl, int inhibit);
extern int LaunchItem(int item, int inhibit);
extern void Create_Launch_Menu(void);
extern void Setup_Themes_Menu(int which);
extern void Create_Themes_Menu(int setThemeDir);
extern void Launch_Startup_Items(void);

#endif
