/*************************************/ 
/* Original oroborus window manager  */
/* (c) Ken Lynch Jan 2001            */
/*                                   */
/* Extra functionality for OroborOSX */
/* (c) Adrian Umpleby Jan 2002       */
/*                                   */
/* Distributed under the GPL         */ 
/* See LICENSE for more details      */ 
/*************************************/ 

/* errors.h */

/*
 * This contains the list of error numbers and their window id names in "alerts.nib"
 */

#ifndef ERRORS_H 
#define ERRORS_H 

#define GOTQUITAE_ERRNO		-1010
#define ASKQUIT_NAME		"AskQuit"

#define FATALMEM_ERRNO		-701
#define FATALMEM_NAME		"FatalMem"

#define NOXDARWIN_ERRNO		-702
#define NOXDARWIN_NAME		"NoXDarwin"

#define OTHERWM_ERRNO		-703
#define OTHERWM_NAME		"OtherWM"

#define XDARWINFAIL_ERRNO	-704
#define XDARWINFAIL_NAME	"XDarwinFail"

#define STARTXFAIL_ERRNO	-705
#define STARTXFAIL_NAME		"StartXFail"

// Return error values from scripts (note that the values are multiplied by 256)
#define NOLMIFLDR_STAT		101*256
#define NOLMIFLDR_NAME		"NoLMIFldr"

#define NOTHEMEFLDR_STAT	103*256
#define NOTHEMEFLDR_NAME	"NoThemeFldr"

#define NOTMPLIST_STAT		102*256
#define NOTMPLIST_NAME		"NoTmpList"

#define NOTEXIST_STAT		126*256
#define NOTEXISTLAUNCH_NAME	"NotExistLaunch"

// Return error values from GetXpid script (multiplied by 256 again)
#define PIDFILEFAIL_NAME	"PIDFileFail"
#define PIDFILEFAIL_ERRNO	51*256

#define LOSTXDARWIN_NAME	"LostXDarwin"
#define LOSTXDARWIN_ERRNO	55*256

#define LOSTPLF_NAME		"LostPLF"
#define LOSTXPLF_ERRNO		56*256

#define INTLVOFF_NAME		"IntlvOff"
#define INTLVOFF_ERRNO		200*256

#define INTLVON_NAME		"IntlvOn"
#define INTLVON_ERRNO		201*256

#define PASSWDFAIL_NAME		"PasswdFail"
#define PASSWDFAIL_ERRNO	203*256	// need to check if $status gives an errno

#define INTLVFAIL_NAME		"IntlvFail" // generic failure message

// some other alerts...
#define WARNMEM_NAME		"WarnMem"
#define READMEPATH_NAME		"ReadmePath"
#define LAUNCHFAIL1_NAME	"LaunchFail1"
#define LAUNCHFAILS_NAME	"LaunchFails"
#define WARNLAUNCH_NAME		"WarnLaunch"
#define NOTHEMES_NAME		"NoThemes"
#define NOCURTHEME_NAME		"NoCurTheme"
#define XDARWINVER_NAME		"XDarwinVer"
#define PASSWINFAIL_NAME	"PassWinFail"
#define INTLVREAD_NAME		"IntlvRead"
#define INTLVONOK_NAME		"IntlvOnOK"
#define INTLVOFFOK_NAME		"IntlvOffOK"
#define HACKWARN_NAME		"HackWarn"
#define HACKREAD_NAME		"HackRead"
#define QUITX11_NAME		"QuitX11"
#define QUITWM_NAME		"QuitWM"

#endif

