/*
 * NSView subclass for Mac OS X rootless X server
 */
/* $XFree86: xc/programs/Xserver/hw/darwin/bundle/XView.h,v 1.3 2001/11/05 05:12:16 torrey Exp $ */

#import <Cocoa/Cocoa.h>

#include <drivers/event_status_driver.h>
#include "fakeBoxRec.h"

@interface XView : NSView
{
    char *mBits;
    int mBytesPerRow;
    int mRows;
    int mBitsPerSample;
    int mSamplesPerPixel;
    int mBitsPerPixel;
    int mDepth;
    int mHackID;
    BOOL mShaped;
    BOOL mDimmed;
    BOOL mInhibitShadowChange;
    BOOL mMiniature;
    BOOL mDrawing;
    BOOL mWaitForDrawRect;
    BOOL mInhibitUpdate;
    BOOL mInhibitRefresh;
    NSRect myFrame;
    unsigned long mDrawAlpha;
    unsigned long mTranslucentBG;
    NSTrackingRectTag mRectTag;
}

- (id)initWithFrame:(NSRect)aRect isRoot:(BOOL)isRoot;
- (void)dealloc;

- (void)drawRect:(NSRect)aRect;
- (BOOL)isFlipped;
- (BOOL)acceptsFirstResponder;
- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent;
- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)theEvent;

- (void)setWaitForDrawRect:(BOOL)val;
- (BOOL)getWaitForDrawRect;

- (void)mouseDown:(NSEvent *)anEvent;
- (void)mouseEntered:(NSEvent *)anEvent;
- (void)mouseExited:(NSEvent *)anEvent;

//- (void)setFrameSize:(NSSize)newSize;
//- (void)setFrame:(NSRect)aRect;

- (void)checkAndAllocBitsForSize:(NSSize)newSize isRoot:(BOOL)isRoot;
- (void)allocBitsForSize:(NSSize)newSize isRoot:(BOOL)isRoot;
- (char *)bits;
- (void)getBits:(char **)bits
       rowBytes:(int *)rowBytes
          depth:(int *)depth
   bitsPerPixel:(int *)bpp;

-(int)SleepingForBitsShape:(int)hundredths warn:(int)warn who:(char *)name;
-(int)SleepingForBits:(int)hundredths warn:(int)warn who:(char *)name;
- (void)refreshRects:(fakeBoxRec *)rectList count:(int)count;
- (void)reshapeRects:(fakeBoxRec *)eraseRects count:(int)count;

- (void)copyToScreen:(fakeBoxRec *)rectList count:(int)count
            fromTemp:(BOOL)copyFromTemp;
- (void)copyAllToShapeBits;
- (void)copyToShapeBits:(fakeBoxRec *)rectList count:(int)count;
- (void)eraseFromShapeBits:(fakeBoxRec *)rectList count:(int)count;
- (void)copyToScreenViaShape:(fakeBoxRec *)rectList count:(int)count;
- (void)setDim:(BOOL)value update:(BOOL)update;
//- (NSRect)frame;
- (BOOL)shadowChangeInhibited;
- (void)setInhibitShadowChange:(BOOL)value;
- (void)setMyMiniature:(BOOL)value;
- (BOOL)getMyMiniature;
- (void)setMyDrawAlpha:(int)alphaval;
- (void)setMyTranslucentAlpha:(int)alphaval;
- (void)setMyTranslucentRed:(int)redval;
- (void)setMyTranslucentGreen:(int)greenval;
- (void)setMyTranslucentBlue:(int)blueval;
- (void)setMyHackID:(int)hackid;
- (int)getMyHackID;
- (NSTrackingRectTag)getMyTrackingRect;
- (void)setMyTrackingRect:(NSTrackingRectTag)tag;
- (void)setInhibitFull:(BOOL)val;
- (void)setInhibitRefresh:(BOOL)val;

@end
