/*
 * NSWindow subclass for Mac OS X rootless X server
 */
/* $XFree86: xc/programs/Xserver/hw/darwin/bundle/XWindow.h,v 1.2 2001/09/17 03:08:40 torrey Exp $ */

#import <Cocoa/Cocoa.h>
#import "XView.h"

#include "fakeBoxRec.h"

@interface XWindow : NSWindow
{
    XView *mView;
    int mWrongThread;
    int mLastTitlePos;
    float mMyAlpha;
    char mTitle[120];
    BOOL mIsRoot;
    NSRect myFrame;
}

- (id)initWithContentRect:(NSRect)aRect
                   isRoot:(BOOL)isRoot;
- (void)dealloc;

- (char *)bits;
- (void)getBits:(char **)bits
       rowBytes:(int *)rowBytes
          depth:(int *)depth
   bitsPerPixel:(int *)bpp;

- (void)reshapeRects:(fakeBoxRec *)eraseRects count:(int)count;

- (void)refreshRects:(fakeBoxRec *)rectList
               count:(int)count;

- (void)orderWindow:(NSWindowOrderingMode)place
         relativeTo:(int)otherWindowNumber;

- (void)setFrame:(NSRect)frame display:(BOOL)val;
- (void)mySetFrame:(NSRect)frame alloc:(BOOL)alloc;
- (void)myDoResize;
- (void)sendEvent:(NSEvent *)anEvent;
- (BOOL)isFlipped;
- (BOOL)canBecomeMainWindow;
- (BOOL)canBecomeKeyWindow;
- (void)setDim:(BOOL)value update:(BOOL)update;
- (void)setInhibitShadowChange:(BOOL)value;
- (BOOL)shadowChangeInhibited;
- (void)setMiniaturization:(BOOL)value;
- (BOOL)getMyMiniature;
- (void)setMyMiniature:(BOOL)value;
- (void)setMyDrawAlpha:(int)alphaval;
- (void)setMyTranslucentAlpha:(int)alphaval;
- (void)setMyTranslucentRed:(int)redval;
- (void)setMyTranslucentGreen:(int)greenval;
- (void)setMyTranslucentBlue:(int)blueval;
- (void)setMyAlphaValue:(float)val;
- (void)resetAlphaValue;
- (BOOL)willHitWindow:(NSPoint)aPt;
- (void)checkThreadFlag;
- (int)getThreadFlag;
- (void)setThreadFlag:(int)value;
- (void)refreshWholeWindow;
- (void)setMyHackID:(int)hackid;
- (int)getMyHackID;
- (void)setMyTitlePart:(int)v;
//- (void)mySetHasShadow:(BOOL)value;
// XWindow delegate
- (void)windowDidDeminiaturize:(NSNotification *)notification;
- (void)windowWillMiniaturize:(NSNotification *)notification;

@end
